Index: src/plugin/src/xplra/GetDataRefTask.h
===================================================================
--- src/plugin/src/xplra/GetDataRefTask.h	(revision 13)
+++ src/plugin/src/xplra/GetDataRefTask.h	(revision 66)
@@ -246,8 +246,10 @@
      * Construct the task for the dataref with the given name.
      *
+     * @param name the name of the dataref
      * @param maxCount the maximal number of items to retrieve. If <0,
      * the function will perform an extra query to retrieve the size of
      * of the dataref's data, which it will store in the task, so
      * later on it can be reused.
+     * @param offset the offset from which to query the array
      */
     GetArrayDataRefTask(const std::string& name,
@@ -257,8 +259,10 @@
      * Construct the task for the given dataref
      *
+     * @param dataRef the dataref
      * @param maxCount the maximal number of items to retrieve. If <0,
      * the function will perform an extra query to retrieve the size
      * of the dataref's data, which it will store in the task, so
      * later on it can be reused.
+     * @param offset the offset from which to query the array
      */
     GetArrayDataRefTask(XPLMDataRef dataRef,
@@ -313,8 +317,10 @@
      * Construct the task for the dataref with the given name.
      *
+     * @param name the name of the dataref
      * @param maxCount the maximal number of data items to
      * retrieve. If <0, the function will perform an extra query to
      * retrieve the size of the dataref's data, which it will store in
      * the task, so later on it can be reused.
+     * @param offset the offset from which to query the array
      */
     GetFloatArrayDataRefTask(const std::string& name,
@@ -324,48 +330,54 @@
      * Construct the task for the given dataref
      *
-     * @param maxBytes the maximal number of data items to
-     * retrieve. If <0, the function will perform an extra query to
-     * retrieve the size of the dataref's data, which it will store in
-     * the task, so later on it can be reused.
-     */
-    GetFloatArrayDataRefTask(XPLMDataRef dataRef,
-                             int maxCount = -1, int offset = 0);
-};
-
-//------------------------------------------------------------------------------
-//------------------------------------------------------------------------------
-
-/**
- * A dataref task which retrieves the value of an integer array.
- */
-class GetIntArrayDataRefTask :
-        public GetArrayDataRefTask<int, GetIntArrayDataRefTask>
-{
-public:
-    /**
-     * Get the data via XPLM
-     */
-    static int queryData(XPLMDataRef dataRef, int* dest,
-                         int offset, int count);
-
-public:
-    /**
-     * Construct the task for the dataref with the given name.
-     *
+     * @param dataRef the dataref
      * @param maxCount the maximal number of data items to
      * retrieve. If <0, the function will perform an extra query to
      * retrieve the size of the dataref's data, which it will store in
      * the task, so later on it can be reused.
-     */
-    GetIntArrayDataRefTask(const std::string& name,
-                           int maxCount = -1, int offset = 0);
-
-    /**
-     * Construct the task for the given dataref
-     *
-     * @param maxBytes the maximal number of data items to
+     * @param offset the offset from which to query the array
+     */
+    GetFloatArrayDataRefTask(XPLMDataRef dataRef,
+                             int maxCount = -1, int offset = 0);
+};
+
+//------------------------------------------------------------------------------
+//------------------------------------------------------------------------------
+
+/**
+ * A dataref task which retrieves the value of an integer array.
+ */
+class GetIntArrayDataRefTask :
+        public GetArrayDataRefTask<int, GetIntArrayDataRefTask>
+{
+public:
+    /**
+     * Get the data via XPLM
+     */
+    static int queryData(XPLMDataRef dataRef, int* dest,
+                         int offset, int count);
+
+public:
+    /**
+     * Construct the task for the dataref with the given name.
+     *
+     * @param name the name of the dataref
+     * @param maxCount the maximal number of data items to
      * retrieve. If <0, the function will perform an extra query to
      * retrieve the size of the dataref's data, which it will store in
      * the task, so later on it can be reused.
+     * @param offset the offset from which to query the array
+     */
+    GetIntArrayDataRefTask(const std::string& name,
+                           int maxCount = -1, int offset = 0);
+
+    /**
+     * Construct the task for the given dataref
+     *
+     * @param dataRef the dataref
+     * @param maxCount the maximal number of data items to
+     * retrieve. If <0, the function will perform an extra query to
+     * retrieve the size of the dataref's data, which it will store in
+     * the task, so later on it can be reused.
+     * @param offset the offset from which to query the array
      */
     GetIntArrayDataRefTask(XPLMDataRef dataRef,
@@ -393,8 +405,10 @@
      * Construct the task for the dataref with the given name.
      *
+     * @param name the name of the dataref
      * @param maxBytes the maximal number of bytes to retrieve. If <0,
      * the function will perform an extra query to retrieve the size
      * of the dataref's data, which it will store in the task, so
      * later on it can be reused.
+     * @param offset the offset from which to query the array
      */
     GetByteArrayDataRefTask(const std::string& name,
@@ -404,8 +418,10 @@
      * Construct the task for the given dataref
      *
+     * @param dataRef the dataref
      * @param maxBytes the maximal number of bytes to retrieve. If <0,
      * the function will perform an extra query to retrieve the size
      * of the dataref's data, which it will store in the task, so
      * later on it can be reused.
+     * @param offset the offset from which to query the array
      */
     GetByteArrayDataRefTask(XPLMDataRef dataRef,
Index: src/plugin/src/xplra/SetDataRefTask.h
===================================================================
--- src/plugin/src/xplra/SetDataRefTask.h	(revision 13)
+++ src/plugin/src/xplra/SetDataRefTask.h	(revision 66)
@@ -62,4 +62,5 @@
      * signifies an error only, if some wrong data is read. If the
      * stream fails, it will indicate RESULT_OK.
+     * @param stream the stream to read from
      *
      * @return the new instance or 0 on error.