Index: src/xplra/DataRefTask.cc
===================================================================
--- src/xplra/DataRefTask.cc	(revision 3)
+++ src/xplra/DataRefTask.cc	(revision 11)
@@ -31,5 +31,5 @@
 #include "DataRefTask.h"
 
-#include "xplcommon/Util.h"
+#include "hu/varadiistvan/xplcommon/Util.h"
 
 //------------------------------------------------------------------------------
@@ -37,5 +37,5 @@
 using xplra::DataRefTask;
 
-using xplcommon::Util;
+using hu::varadiistvan::xplcommon::Util;
 
 //------------------------------------------------------------------------------
Index: src/xplra/GetDataRefTask.cc
===================================================================
--- src/xplra/GetDataRefTask.cc	(revision 8)
+++ src/xplra/GetDataRefTask.cc	(revision 11)
@@ -32,5 +32,5 @@
 #include "Protocol.h"
 
-#include "xplcommon/Util.h"
+#include "hu/varadiistvan/xplcommon/Util.h"
 
 //------------------------------------------------------------------------------
@@ -41,6 +41,6 @@
 using xplra::GetDoubleDataRefTask;
 
-using xplcommon::DataStream;
-using xplcommon::Util;
+using hu::varadiistvan::scpl::io::DataStream;
+using hu::varadiistvan::xplcommon::Util;
 
 using std::string;
Index: src/xplra/GetDataRefTask.h
===================================================================
--- src/xplra/GetDataRefTask.h	(revision 6)
+++ src/xplra/GetDataRefTask.h	(revision 11)
@@ -33,5 +33,5 @@
 #include "DataRefTask.h"
 
-#include <xplcommon/DataStream.h>
+#include <hu/varadiistvan/scpl/io/DataStream.h>
 
 //------------------------------------------------------------------------------
@@ -55,5 +55,6 @@
      * unless the stream failed, in which case it remains RESULT_OK.
      */
-    static GetDataRefTask* create(uint8_t& result, xplcommon::DataStream& stream);
+    static GetDataRefTask* create(uint8_t& result,
+                                  hu::varadiistvan::scpl::io::DataStream& stream);
 
     /**
@@ -70,5 +71,5 @@
      * Write the value into the given stream.
      */
-    virtual void writeValue(xplcommon::DataStream& stream) = 0;
+    virtual void writeValue(hu::varadiistvan::scpl::io::DataStream& stream) = 0;
 };
 
@@ -141,5 +142,5 @@
      * Write the value into the given stream.
      */
-    virtual void writeValue(xplcommon::DataStream& stream);
+    virtual void writeValue(hu::varadiistvan::scpl::io::DataStream& stream);
 };
 
@@ -173,5 +174,5 @@
      * Write the value into the given stream.
      */
-    virtual void writeValue(xplcommon::DataStream& stream);
+    virtual void writeValue(hu::varadiistvan::scpl::io::DataStream& stream);
 };
 
@@ -205,5 +206,5 @@
      * Write the value into the given stream.
      */
-    virtual void writeValue(xplcommon::DataStream& stream);
+    virtual void writeValue(hu::varadiistvan::scpl::io::DataStream& stream);
 };
 
@@ -289,5 +290,5 @@
      * Write the value into the given stream.
      */
-    virtual void writeValue(xplcommon::DataStream& stream);
+    virtual void writeValue(hu::varadiistvan::scpl::io::DataStream& stream);
 };
 
@@ -533,5 +534,5 @@
 template <typename T, class ConcreteClass>
 void GetArrayDataRefTask<T, ConcreteClass>::
-writeValue(xplcommon::DataStream& stream)
+writeValue(hu::varadiistvan::scpl::io::DataStream& stream)
 {
     stream.writeS32(length);
Index: src/xplra/GetMultiDataRefRequest.cc
===================================================================
--- src/xplra/GetMultiDataRefRequest.cc	(revision 10)
+++ src/xplra/GetMultiDataRefRequest.cc	(revision 11)
@@ -33,5 +33,5 @@
 #include "Protocol.h"
 
-#include <xplcommon/Util.h>
+#include <hu/varadiistvan/xplcommon/Util.h>
 
 //------------------------------------------------------------------------------
@@ -39,6 +39,6 @@
 using xplra::GetMultiDataRefRequest;
 
-using xplcommon::DataStream;
-using xplcommon::Util;
+using hu::varadiistvan::scpl::io::DataStream;
+using hu::varadiistvan::xplcommon::Util;
 
 //------------------------------------------------------------------------------
@@ -66,5 +66,5 @@
 //------------------------------------------------------------------------------
 
-void GetMultiDataRefRequest::writeResult(xplcommon::DataStream& stream) const
+void GetMultiDataRefRequest::writeResult(DataStream& stream) const
 {
     // Util::debug("hu.varadiistvan.xplra.GetMultiDataRefRequest[%p]::writeResult\n", this);
Index: src/xplra/GetMultiDataRefRequest.h
===================================================================
--- src/xplra/GetMultiDataRefRequest.h	(revision 10)
+++ src/xplra/GetMultiDataRefRequest.h	(revision 11)
@@ -50,5 +50,5 @@
      * specifications from the given stream.
      */
-    GetMultiDataRefRequest(uint8_t& result, xplcommon::DataStream& stream);
+    GetMultiDataRefRequest(uint8_t& result, hu::varadiistvan::scpl::io::DataStream& stream);
 
     /**
@@ -62,5 +62,5 @@
      * the datarefs queried.
      */
-    void writeResult(xplcommon::DataStream& stream) const;
+    void writeResult(hu::varadiistvan::scpl::io::DataStream& stream) const;
 };
 
Index: src/xplra/ListenThread.cc
===================================================================
--- src/xplra/ListenThread.cc	(revision 3)
+++ src/xplra/ListenThread.cc	(revision 11)
@@ -33,7 +33,7 @@
 #include "ServerThread.h"
 
-#include <xplcommon/LocalServerSocket.h>
-#include <xplcommon/LocalAcceptor.h>
-#include <xplcommon/Util.h>
+#include <hu/varadiistvan/scpl/io/LocalServerSocket.h>
+#include <hu/varadiistvan/scpl/io/LocalAcceptor.h>
+#include <hu/varadiistvan/xplcommon/Util.h>
 
 //------------------------------------------------------------------------------
@@ -41,7 +41,7 @@
 using xplra::ListenThread;
 
-using xplcommon::LocalServerSocket;
-using xplcommon::LocalAcceptor;
-using xplcommon::Util;
+using hu::varadiistvan::scpl::io::LocalServerSocket;
+using hu::varadiistvan::scpl::io::LocalAcceptor;
+using hu::varadiistvan::xplcommon::Util;
 
 //------------------------------------------------------------------------------
Index: src/xplra/ListenThread.h
===================================================================
--- src/xplra/ListenThread.h	(revision 2)
+++ src/xplra/ListenThread.h	(revision 11)
@@ -31,9 +31,10 @@
 //------------------------------------------------------------------------------
 
+#include <hu/varadiistvan/scpl/Thread.h>
+
 #include "RequestQueue.h"
 
-#include <xplcommon/Thread.h>
-#include <xplcommon/Waiter.h>
-#include <xplcommon/WaitableEvent.h>
+#include <hu/varadiistvan/scpl/io/Waiter.h>
+#include <hu/varadiistvan/scpl/io/WaitableEvent.h>
 
 //------------------------------------------------------------------------------
@@ -49,5 +50,5 @@
  * This is a detached thread, to allow it to quit automatically.
  */
-class ListenThread : public xplcommon::Thread
+class ListenThread : public hu::varadiistvan::scpl::Thread
 {
 private:
@@ -55,5 +56,5 @@
      * The waiter used in the thread.
      */
-    xplcommon::Waiter waiter;
+    hu::varadiistvan::scpl::io::Waiter waiter;
 
     /**
@@ -61,5 +62,5 @@
      * quit.
      */
-    xplcommon::WaitableEvent quitEvent;
+    hu::varadiistvan::scpl::io::WaitableEvent quitEvent;
 
     /**
Index: src/xplra/Makefile.am
===================================================================
--- src/xplra/Makefile.am	(revision 9)
+++ src/xplra/Makefile.am	(revision 11)
@@ -1,5 +1,5 @@
 INCLUDES=@XPSDK_INCLUDES@
 
-AM_CXXFLAGS=$(LIBXPLCOMMON_CFLAGS)
+AM_CXXFLAGS=$(VSCPL_CFLAGS) $(LIBXPLCOMMON_CFLAGS)
 
 AM_CPPFLAGS=-DXPLM210
@@ -18,4 +18,5 @@
 AM_CPPFLAGS+=-DLIN
 AM_CXXFLAGS+=-fPIC -fno-stack-protector
+AM_LDFLAGS=-rdynamic -nodefaultlibs -undefined_warning -Wl,-version-script=$(srcdir)/version.ldscript
 endif
 
@@ -36,5 +37,5 @@
 	SetMultiDataRefRequest.cc
 
-libxplra_la_LIBADD=$(LIBXPLCOMMON_LIBS)
+libxplra_la_LIBADD=$(VSCPL_LIBS) $(LIBXPLCOMMON_LIBS)
 
 noinst_HEADERS= \
Index: src/xplra/MultiTaskRequest.cc
===================================================================
--- src/xplra/MultiTaskRequest.cc	(revision 8)
+++ src/xplra/MultiTaskRequest.cc	(revision 11)
@@ -33,5 +33,5 @@
 #include "Task.h"
 
-#include <xplcommon/Util.h>
+#include <hu/varadiistvan/xplcommon/Util.h>
 
 //------------------------------------------------------------------------------
@@ -39,5 +39,5 @@
 using xplra::MultiTaskRequest;
 
-using xplcommon::Util;
+using hu::varadiistvan::xplcommon::Util;
 
 //------------------------------------------------------------------------------
Index: src/xplra/RequestQueue.cc
===================================================================
--- src/xplra/RequestQueue.cc	(revision 2)
+++ src/xplra/RequestQueue.cc	(revision 11)
@@ -33,5 +33,5 @@
 #include "Request.h"
 
-#include <xplcommon/Util.h>
+#include <hu/varadiistvan/xplcommon/Util.h>
 
 //------------------------------------------------------------------------------
@@ -39,5 +39,5 @@
 using xplra::RequestQueue;
 
-using xplcommon::Util;
+using hu::varadiistvan::xplcommon::Util;
 
 //------------------------------------------------------------------------------
Index: src/xplra/RequestQueue.h
===================================================================
--- src/xplra/RequestQueue.h	(revision 2)
+++ src/xplra/RequestQueue.h	(revision 11)
@@ -31,6 +31,6 @@
 //------------------------------------------------------------------------------
 
-#include <xplcommon/Mutex.h>
-#include <xplcommon/CondVar.h>
+#include <hu/varadiistvan/scpl/Mutex.h>
+#include <hu/varadiistvan/scpl/CondVar.h>
 
 #include <XPLMProcessing.h>
@@ -96,5 +96,5 @@
      * The mutex protecting the queue.
      */
-    xplcommon::Mutex mutex;
+    hu::varadiistvan::scpl::Mutex mutex;
 
     /**
@@ -102,5 +102,5 @@
      * request to be executed.
      */
-    xplcommon::CondVar requestsDone;
+    hu::varadiistvan::scpl::CondVar requestsDone;
 
     /**
Index: src/xplra/ServerThread.cc
===================================================================
--- src/xplra/ServerThread.cc	(revision 10)
+++ src/xplra/ServerThread.cc	(revision 11)
@@ -39,5 +39,5 @@
 #include "SetMultiDataRefRequest.h"
 
-#include <xplcommon/Util.h>
+#include <hu/varadiistvan/xplcommon/Util.h>
 
 #include <cstdio>
@@ -47,7 +47,7 @@
 using xplra::ServerThread;
 
-using xplcommon::LocalAcceptor;
-using xplcommon::Mutex;
-using xplcommon::Util;
+using hu::varadiistvan::scpl::io::LocalAcceptor;
+using hu::varadiistvan::scpl::Mutex;
+using hu::varadiistvan::xplcommon::Util;
 
 using std::string;
Index: src/xplra/ServerThread.h
===================================================================
--- src/xplra/ServerThread.h	(revision 10)
+++ src/xplra/ServerThread.h	(revision 11)
@@ -31,12 +31,12 @@
 //------------------------------------------------------------------------------
 
-#include <xplcommon/Thread.h>
-
-#include <xplcommon/Mutex.h>
-
-#include <xplcommon/Waiter.h>
-#include <xplcommon/BufferedStream.h>
-#include <xplcommon/DataStream.h>
-#include <xplcommon/LocalAcceptor.h>
+#include <hu/varadiistvan/scpl/Thread.h>
+
+#include <hu/varadiistvan/scpl/io/Waiter.h>
+#include <hu/varadiistvan/scpl/io/BufferedStream.h>
+#include <hu/varadiistvan/scpl/io/DataStream.h>
+#include <hu/varadiistvan/scpl/io/LocalAcceptor.h>
+
+#include <hu/varadiistvan/scpl/Mutex.h>
 
 #include <set>
@@ -59,5 +59,5 @@
  * A thread serving a client.
  */
-class ServerThread : public xplcommon::Thread
+class ServerThread : public hu::varadiistvan::scpl::Thread
 {
 private:
@@ -80,5 +80,5 @@
      * A mutex to protect the collection of server threads.
      */
-    static xplcommon::Mutex instancesMutex;
+    static hu::varadiistvan::scpl::Mutex instancesMutex;
 
     /**
@@ -102,15 +102,15 @@
      * Our waiter.
      */
-    xplcommon::Waiter waiter;
+    hu::varadiistvan::scpl::io::Waiter waiter;
 
     /**
      * The buffered stream to use for communication at the low-level.
      */
-    xplcommon::BufferedStream* bufferedStream;
+    hu::varadiistvan::scpl::io::BufferedStream* bufferedStream;
 
     /**
      * The data stream being used for communication.
      */
-    xplcommon::DataStream stream;
+    hu::varadiistvan::scpl::io::DataStream stream;
 
     /**
@@ -140,5 +140,5 @@
      */
     ServerThread(RequestQueue& requestQueue,
-                 xplcommon::LocalAcceptor& acceptor);
+                 hu::varadiistvan::scpl::io::LocalAcceptor& acceptor);
 
     /**
Index: src/xplra/SetDataRefTask.cc
===================================================================
--- src/xplra/SetDataRefTask.cc	(revision 9)
+++ src/xplra/SetDataRefTask.cc	(revision 11)
@@ -40,5 +40,5 @@
 using xplra::SetDoubleDataRefTask;
 
-using xplcommon::DataStream;
+using hu::varadiistvan::scpl::io::DataStream;
 
 using std::string;
Index: src/xplra/SetDataRefTask.h
===================================================================
--- src/xplra/SetDataRefTask.h	(revision 9)
+++ src/xplra/SetDataRefTask.h	(revision 11)
@@ -33,5 +33,5 @@
 #include "DataRefTask.h"
 
-#include <xplcommon/DataStream.h>
+#include <hu/varadiistvan/scpl/io/DataStream.h>
 
 //------------------------------------------------------------------------------
@@ -65,5 +65,5 @@
      * @return the new instance or 0 on error.
      */
-    static SetDataRefTask* create(uint8_t& result, xplcommon::DataStream& stream);
+    static SetDataRefTask* create(uint8_t& result, hu::varadiistvan::scpl::io::DataStream& stream);
 
     /**
@@ -80,5 +80,5 @@
      * Read and set the value to update from the given stream
      */
-    virtual void readValue(xplcommon::DataStream& stream) = 0;
+    virtual void readValue(hu::varadiistvan::scpl::io::DataStream& stream) = 0;
 };
 
@@ -150,5 +150,5 @@
      * Read and set the value to update from the given stream
      */
-    virtual void readValue(xplcommon::DataStream& stream);
+    virtual void readValue(hu::varadiistvan::scpl::io::DataStream& stream);
 };
 
@@ -181,5 +181,5 @@
      * Read and set the value to update from the given stream
      */
-    virtual void readValue(xplcommon::DataStream& stream);
+    virtual void readValue(hu::varadiistvan::scpl::io::DataStream& stream);
 };
 
@@ -212,5 +212,5 @@
      * Read and set the value to update from the given stream
      */
-    virtual void readValue(xplcommon::DataStream& stream);
+    virtual void readValue(hu::varadiistvan::scpl::io::DataStream& stream);
 };
 
@@ -270,5 +270,5 @@
      * Read and set the value to update from the given stream
      */
-    virtual void readValue(xplcommon::DataStream& stream);
+    virtual void readValue(hu::varadiistvan::scpl::io::DataStream& stream);
 
 protected:
@@ -424,5 +424,5 @@
 template <typename T, class ConcreteClass>
 void SetArrayDataRefTask<T, ConcreteClass>::
-readValue(xplcommon::DataStream& stream)
+readValue(hu::varadiistvan::scpl::io::DataStream& stream)
 {
     stream.read(value, count * sizeof(T));
Index: src/xplra/SetMultiDataRefRequest.cc
===================================================================
--- src/xplra/SetMultiDataRefRequest.cc	(revision 10)
+++ src/xplra/SetMultiDataRefRequest.cc	(revision 11)
@@ -37,5 +37,5 @@
 using xplra::SetMultiDataRefRequest;
 
-using xplcommon::DataStream;
+using hu::varadiistvan::scpl::io::DataStream;
 
 //------------------------------------------------------------------------------
Index: src/xplra/SetMultiDataRefRequest.h
===================================================================
--- src/xplra/SetMultiDataRefRequest.h	(revision 10)
+++ src/xplra/SetMultiDataRefRequest.h	(revision 11)
@@ -50,5 +50,6 @@
      * the given stream.
      */
-    SetMultiDataRefRequest(uint8_t& result, xplcommon::DataStream& stream,
+    SetMultiDataRefRequest(uint8_t& result,
+                           hu::varadiistvan::scpl::io::DataStream& stream,
                            bool readValues);
 
@@ -56,5 +57,5 @@
      * Read the values of all tasks.
      */
-    void readValues(xplcommon::DataStream& stream);
+    void readValues(hu::varadiistvan::scpl::io::DataStream& stream);
 
     /**
@@ -67,5 +68,5 @@
      * Otherwise the result is RESULT_OK.
      */
-    void writeResult(xplcommon::DataStream& stream) const;
+    void writeResult(hu::varadiistvan::scpl::io::DataStream& stream) const;
 };
 
Index: src/xplra/plugin.cc
===================================================================
--- src/xplra/plugin.cc	(revision 9)
+++ src/xplra/plugin.cc	(revision 11)
@@ -31,6 +31,6 @@
 #include "ListenThread.h"
 
-#include <xplcommon/Util.h>
-#include <xplcommon/config.h>
+#include <hu/varadiistvan/xplcommon/Util.h>
+#include <hu/varadiistvan/scpl/config.h>
 
 #include <XPLMDefs.h>
@@ -50,5 +50,5 @@
 using xplra::ListenThread;
 
-using xplcommon::Util;
+using hu::varadiistvan::xplcommon::Util;
 
 //------------------------------------------------------------------------------
Index: src/xplra/version.ldscript
===================================================================
--- src/xplra/version.ldscript	(revision 11)
+++ src/xplra/version.ldscript	(revision 11)
@@ -0,0 +1,10 @@
+{
+ global:
+  XPluginStart;
+  XPluginStop;
+  XPluginEnable;
+  XPluginDisable;
+  XPluginReceiveMessage;
+ local:
+   *;
+};